import { ConversionData, MarkPlugin, PluginOptions, SchemaMark } from '@aomao/engine';
export interface BackcolorOptions extends PluginOptions {
    hotkey?: {
        key: string;
        args: Array<string>;
    };
}
export default class<T extends BackcolorOptions = BackcolorOptions> extends MarkPlugin<T> {
    static get pluginName(): string;
    readonly mergeLeval = 2;
    tagName: string;
    style: {
        'background-color': string;
    };
    variable: {
        '@var0': {
            required: boolean;
            value: string;
        };
    };
    schema(): SchemaMark | SchemaMark[];
    conversion(): ConversionData;
    isTrigger(color: string, defaultColor?: string): boolean;
    hotkey(): {
        key: string;
        args: string[];
    } | never[];
}
